-- fsource="N:\\_3DMODELS\\Ripped\\XenosagaIII\\C3kosmos17\\C3kosmos17.chr"
-- fsource="T:\\_MODS\\xenosaga\\Xeno3TradKit\\Xenosaga3\\mdl\\chr\\cit\\C3rat00.chr"

-- fsource="T:\\_MODS\\xenosaga\\Xeno3TradKit\\Xenosaga3\\mdl\\chr\\pc\\C3momo00.pxy"

fsource = GetOpenFileName \
caption:"[PC] XnaLara Mesh File" \
types: "All files (*.*)|*.*|"


clearlistener()
if (fsource!=undefined) AND ((doesFileExist fsource)==true) then(
f = fopen fsource "rb"

fn ReadBEfloat fstream = (
	fpt=readfloat fstream
	itger = bit.floatAsInt fpt
	hih = bit.intashex itger
	while hih.count < 8 do hih = "0" + hih
	shn = (substring hih 7 2) + \
	(substring hih 5 2) + \
	(substring hih 3 2) + \
	(substring hih 1 2)
	bit.intAsFloat (bit.hexasint shn)
	)
	
	fn readBEshort fstream = (
short = readshort fstream #unsigned
short = bit.swapBytes short 1 2
return short
) 
fn readBElong fstream = (
long = readlong fstream #unsigned
long = bit.swapBytes long 1 4
long = bit.swapBytes long 2 3
return long
)

fn ReadFixedString bstream fixedLen = (
   local str = ""
   for i = 1 to fixedLen do
   (
      str += bit.intAsChar (ReadByte bstream #unsigned)
   )
   str
)

fn readBEHalfFloat fstream = (
hf=bit.swapBytes (readshort fstream #unsigned) 1 2
sign = bit.get hf 16
exponent = (bit.shift (bit.and hf (bit.hexasint "7C00")) -10) as integer - 16
fraction = bit.and hf (bit.hexasint "03FF")
if sign==true then sign = 1 else sign = 0
exponentF = exponent + 127
outputAsFloat = bit.or (bit.or (bit.shift fraction 13) \
(bit.shift exponentF 23)) (bit.shift sign 31)
return bit.intasfloat outputasfloat*2)

fn readHalfFloat fstream = (
hf=readshort fstream #unsigned
sign = bit.get hf 16
exponent = (bit.shift (bit.and hf (bit.hexasint "7C00")) -10) as integer - 16
fraction = bit.and hf (bit.hexasint "03FF")
if sign==true then sign = 1 else sign = 0
exponentF = exponent + 127
outputAsFloat = bit.or (bit.or (bit.shift fraction 13) \
(bit.shift exponentF 23)) (bit.shift sign 31)
return bit.intasfloat outputasfloat*2)

fn readVIFcmd fstream = (
result=#()
result[5]=0
CMD_01=readbyte fstream #unsigned -- writting address, usually 0
CMD_02=readbyte fstream #unsigned -- bit flags
CMD_03=readbyte fstream #unsigned -- *16 = size
CMD_04=readbyte fstream #unsigned -- data type flag
CMD_04_0=0
CMD_04_1=0;CMD_04_1=bit.set (bit.set CMD_04_1 1 (bit.get CMD_04 1)) 2 (bit.get CMD_04 2)
CMD_04_2=0;CMD_04_2=bit.set (bit.set CMD_04_2 1 (bit.get CMD_04 3)) 2 (bit.get CMD_04 4)
CMD_04_3=0;CMD_04_3=bit.set (bit.set CMD_04_3 1 (bit.get CMD_04 5)) 2 (bit.get CMD_04 6)
CMD_04_4=0;CMD_04_4=bit.set (bit.set CMD_04_4 1 (bit.get CMD_04 7)) 2 (bit.get CMD_04 8)
case of(
(CMD_04_1 == 0): CMD_04_0=4 -- Long
(CMD_04_1 == 1): CMD_04_0=2 -- Short
(CMD_04_1 == 2): CMD_04_0=1 -- Byte
(CMD_04_1 == 3): CMD_04_0=2) -- 4 bit flags, usually RGBA colours
result[1]=CMD_01
result[2]=CMD_02
result[3]=CMD_03
result[4]=CMD_04
result[5]=(ftell fstream+(CMD_04_0*(CMD_04_2+1)*CMD_03))
return result
)

fn imSkin msh tp ba bn we bp = (
skinMod = skin ()
max modify mode
addModifier msh skinMod
modPanel.setCurrentObject skinMod

for x = 1 to ba.count do( -- Add bones to SKIN modifier from bone array
skinOps.addBone skinMod ba[x] 1)

-- for x = 1 to bp.count do(;if bp[x]!=0 do( -- Add bones to SKIN modifier from pallet
-- skinOps.addBone skinMod ba[(bp[x])] 1))


skincount= (skinOps.GetNumberBones skinMod)
for x = 1 to msh.numverts do(
bi=#();wv=#();for j = 1 to 4 do(
boneid =bn[x][j]
if boneid != 0xFF do (
boneid =((boneid/4)+1) as integer
-- if boneid<=bp.count do(
-- bonetest=bp[boneid]
-- if bonetest!=0 do(
-- 	boneid=bonetest
-- 	
-- )
-- 	


-- )
	

boneid = bp[boneid] -- alt method
	




weight = we[x][j]	
if boneid>=(skincount+1) OR boneid<=0 do(
PRINT ("BAD BoneIndex: "+(boneid as string)+"/"+(skincount as string)+" was not found...");boneid=1)
if bn[x][j]!=0xFF do (append bi boneid;append wv weight)

)
) -- seek 4 bone weights
skinOps.ReplaceVertexWeights skinMod x bi wv

))

fn imSkinNOGOOD msh ba bn we bp = (
	
skinMod = skin ()
max modify mode
addModifier msh skinMod
modPanel.setCurrentObject skinMod

for x = 1 to bp.count do(;if bp[x]!=0 do( -- Add bones to SKIN modifier from pallet
skinOps.addBone skinMod ba[(bp[x])] 1))

skincount= (skinOps.GetNumberBones skinMod)
for x = 1 to msh.numverts do(
bi=#();wv=#();for j = 1 to 4 do(
boneid =bn[x][j]
if boneid == 0xFF do boneid=0
boneid =((boneid/4)+1) as integer
wat=boneid
boneid=findItem bp boneid
if boneid==0 do(
-- 	print "failed to find"
-- 	print wat
	boneid=1
	)

weight = we[x][j]	
if boneid>=(skincount+1) OR boneid<=0 do(
PRINT ("BAD BoneIndex: "+(boneid as string)+"/"+(skincount as string)+" was not found...");boneid=1)
if bn[x][j]!=0xFF do (append bi boneid;append wv weight)) -- seek 4 bone weights
skinOps.ReplaceVertexWeights skinMod x bi wv))


mscale=39.3700787
skinON=true
normON=false


blocID=readlong f #unsigned
-- if blocID!=0x00797870 do fseek f 0x80#seek_set;blocID=readlong f #unsigned

if blocID==0x00016358 do (
dataSize1=readlong f #unsigned
dataSize2=readlong f #unsigned --repeated? maybe used for compression?
dataCount=readshort f #unsigned
ukn=readshort f #unsigned
for i = 1 to dataCount do(
dataExt=readlong f #unsigned
if dataExt==0x00797870 do blocID=dataExt)
fseek f 32 #seek_cur -- padding?
for i = 1 to dataCount do(
dataOffset=readlong f #unsigned
dataSize=readlong f #unsigned)	
fseek f (32+4) #seek_cur) -- padding?

if blocID==0x00797870 do ( -- PXY File
offset=ftell f-4
offsetArray=#()
nodeArray=#()
ukn01=readbyte f #unsinged -- ID ?? Flags??
ukn02=readbyte f #unsinged
ukn03=readbyte f #unsinged
ukn04=readbyte f #unsinged

count=readlong f #unsigned
size=readlong f #unsigned
mshName=ReadFixedString f 32 --;print mshName

ukn01_count=readlong f #unsigned
ukn02b_count=readlong f #unsigned -- mesh Count?
ukn03_count=readlong f #unsigned -- 
ukn01_offset=readlong f #unsigned + offset -- offset tabe for the mesh strips
ukn02_offset=readlong f #unsigned + offset -- offsets to bounding box info?

frame_count=readlong f #unsigned
mat_count=readlong f #unsigned
vert_offset=readlong f #unsigned + offset -- table before vertex data. 32bytes/ukn05_count

ukn02_count=readlong f #unsigned;print matd_count
frame_offset=readlong f #unsigned + offset -- to the material table???
mat_offset=readlong f #unsigned + offset -- empty space after the main pxy header?

bone_count=readlong f #unsigned
print ("Total # Bones: "+(bone_count as string))
msh_count=readlong f #unsigned
bone_offset=readlong f #unsigned + offset -- obj positions.. appears to be matrix data
ukn07_offset=readlong f #unsigned + offset -- bone  positions.. each entry is 64bytes, but cannot fid count

mshName_offset=readlong f #unsigned + offset -- bones

-- Print ("Look Here @ 0x"+((bit.intAsHex(ukn06_offset))as string))

fseek f ukn01_offset #seek_set
meshOffsets=#()
meshOffsets[ukn02_count]=[0,0]
offsetArray[mat_count]=[0,0]
palletindex=#()
for i = 1 to ukn02_count do(
ukn02_01=readlong f #unsigned -- offset to gemetry block
ukn02_02=readlong f #unsigned*16 -- size
ukn02_03=readlong f #unsigned -- Index
ukn02_04=readlong f #unsigned+1 -- mesh Index?
ukn02_05=readlong f #unsigned -- ??
ukn02_06=readfloat f --?bound box?
ukn02_07=readfloat f --?bound box?
ukn02_08=readfloat f --?bound box?

meshOffsets[i]=[(ukn02_01+ offset),ukn02_02]
)

-- read instance data
wtfisyous=#()
-- wtfisyous2=#()
fseek f ukn02_offset #seek_set
for i = 1 to mat_count do(

fseek f 4 #seek_cur
mindex = readlong f #unsigned+1 -- mesh Index
offsetArray[i] = meshOffsets[mindex]

fseek f 8 #seek_cur
pindex = readlong f #unsigned+1 -- palette Index
append wtfisyous pindex
append palletindex pindex

fseek f 76 #seek_cur
-- 24 longs
-- 01 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  01 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  20 DA B4 BD 50 02 BB 3F  B0 F4 00 BE 00 00 00 00  20 DA B4 3D 37 18 DC 3F  F4 59 97 3D 00 00 00 00  00 00 00 00 44 8D CB 3F  D8 1E D5 BC 4F 28 3E 3E  00 00 00 00 44 8D CB 3F  D8 1E D5 BC 4F 8C 08 3E
-- 01 00 00 00 01 00 00 00  00 00 00 00 00 00 00 00  00 00 00 00 01 00 00 00  00 00 00 00 00 00 00 00  20 00 FC BE 76 87 56 39  55 E6 1D BE 00 00 00 00  20 00 FC 3E 6C 9C C5 3F  EC 6D 10 3E 00 00 00 00  00 00 00 00 20 A3 45 3F  90 86 D7 BB 71 5E 6D 3F  00 00 00 00 20 A3 45 3F  90 86 D7 BB A9 8B 03 3F
-- 01 00 00 00 02 00 00 00  00 00 00 00 00 00 00 00  02 00 00 00 02 00 00 00  11 00 00 00 00 00 00 00  78 70 B6 BD 70 13 C5 3F  20 44 16 BE 00 00 00 00  77 70 B6 3D 4A 0A E0 3F  2A 5D 95 3D 00 00 00 00  00 00 80 B1 DD 8E D2 3F  16 2B 17 BD 40 91 34 3E  00 00 80 B1 DD 8E D2 3F  16 2B 17 BD AF D0 10 3E
-- 01 00 00 00 03 00 00 00  00 00 00 00 00 00 00 00  03 00 00 00 03 00 00 00  11 00 00 00 00 00 00 00  C2 AD AB BD 9C 6F CF 3F  D8 F8 8C BD 00 00 00 00  C2 AD AB 3D 89 C7 DF 3F  37 8A A4 3D 00 00 00 00  00 00 00 00 92 9B D7 3F  F8 8A BC 3B 1F 32 04 3E  00 00 00 00 92 9B D7 3F  F8 8A BC 3B C4 CC E5 3D
-- 01 00 00 00 02 00 00 00  00 00 00 00 00 00 00 00  02 00 00 00 04 00 00 00  11 00 00 00 00 00 00 00  78 70 B6 BD 70 13 C5 3F  20 44 16 BE 00 00 00 00  77 70 B6 3D 4A 0A E0 3F  2A 5D 95 3D 00 00 00 00  00 00 80 B1 DD 8E D2 3F  16 2B 17 BD 40 91 34 3E  00 00 80 B1 DD 8E D2 3F  16 2B 17 BD AF D0 10 3E
-- 01 00 00 00 03 00 00 00  00 00 00 00 00 00 00 00  03 00 00 00 05 00 00 00  11 00 00 00 00 00 00 00  C2 AD AB BD 9C 6F CF 3F  D8 F8 8C BD 00 00 00 00  C2 AD AB 3D 89 C7 DF 3F  37 8A A4 3D 00 00 00 00  00 00 00 00 92 9B D7 3F  F8 8A BC 3B 1F 32 04 3E  00 00 00 00 92 9B D7 3F  F8 8A BC 3B C4 CC E5 3D
)
-- for x = 1 to ukn02_count do(
-- shit = wtfisyous2[(palletindex[x])]
-- 	if shit==undefined do shit=1
-- append wtfisyous shit
-- )


fseek f mshName_offset #seek_set
mshNames=#()
bonePallet=#()
mshNames[msh_count]=""
for i = 1 to msh_count do(
bi=#()
bi[64]=0
mshNames[i]=ReadFixedString f 32
node_ukn01=readlong f #unsigned
node_ukn02=readlong f #unsigned
node_ukn03=readlong f #unsigned
node_ukn04=readlong f #unsigned -- parent index?
	bcntr=0
for b = 1 to 64 do(
	bi[b] = readbyte f #unsigned
	if (bi[b] != 0) do bcntr += 1
)
print ("Pallet "+(i as string)+" lists "+(bcntr as string)+" bones ("+mshNames[i]+")")
append bonePallet bi
)
-- Print ("Look Here @ 0x"+((bit.intAsHex(ftell f))as string))


fseek f mat_offset #seek_set
matNames=#()
matNames[mat_count]=""
for i = 1 to mat_count do(
matNames[i]=ReadFixedString f 32
fseek f 64 #seek_cur -- skips material info, colour? spec?, texture index?
)  --;print matNames
-- (matrix3 [1,0,0] [0,1,0] [0,0,1] [-0.546067,2.06948,0])
-- (matrix3 [2,0,0] [0,2,0] [0,0,2] [-1.09213,4.13896,0])

if skinON==true do(
fseek f bone_offset #seek_set
for i = 1 to bone_count do(
m11 = readfloat f; m12 = readfloat f; m13 = readfloat f;m14 = readfloat f
m21 = readfloat f; m22 = readfloat f; m23 = readfloat f;m24 = readfloat f
m31 = readfloat f; m32 = readfloat f; m33 = readfloat f;m34 = readfloat f
m41 = readfloat f*mscale; m42 = readfloat f*mscale; m43 = readfloat f*mscale;m44 = readfloat f
tfm = matrix3 [m11,m12,m13] [-m31,-m32,-m33] [m21,m22,m23] [m41,m42,m43]

	
newBone = bonesys.createbone	\
				  tfm.row4	\
				  (tfm.row4 + 0.01 * (normalize tfm.row1)) \
				  (normalize tfm.row3)
-- 			newBone.name = a as string
			newBone.width  = 0.01
			newBone.height = 0.01
			newBone.transform = inverse tfm
			newBone.setBoneEnable false 0
			newBone.wirecolor = yellow
			newbone.showlinks = true
			newBone.pos.controller      = TCB_position ()
			newBone.rotation.controller = TCB_rotation ()	
append nodeArray newBone
))
-- $.transform

fseek f vert_offset #seek_set
for i = 1 to mat_count do(
	hereiam=ftell f
-- if mshNames[(wtfisyous[i])]=="C3momo00_face" do Print ("FACE @ 0x"+((bit.intAsHex(ftell f))as string))
	
counter=0
wcnt=0
vertArray=#()
colorArray=#()
uvwArray=#()
normArray=#()
faceArray=#()
boneidArray=#()
weightArray=#()
cnt=0
adr=0
fseek f offsetArray[i][1] #seek_set
while (ftell f)!=(offsetArray[i][1]+offsetArray[i][2]) do(
if keyboard.escPressed then exit
vindex=1
-- VIF_01=readbyte f #unsigned -- Read
-- VIF_02=readbyte f #unsigned -- Write
-- VIF_03=readbyte f #unsigned -- always 0?
-- VIF_04=readbyte f #unsigned -- Data ID, 01 = PS2 Strip
vifTag=readlong f #unsigned
tempWeights=#()
tempBoneids=#()





















-- if VIF_04!=0 do(
	if vifTag==0x01000101 do(
	
	
	do(
-- Print ("DATABLOCK @ 0x"+((bit.intAsHex(ftell f))as string))
vifCMD=readVIFcmd f

if vifCMD[4]!=0x17 do(
GEO_01=readbyte f #unsigned -- count
GEO_02=readbyte f #unsigned -- flags
GEO_03=readbyte f #unsigned -- always 0
GEO_04=readbyte f #unsigned -- always 0
GEO_05=readlong f #unsigned -- ID Type
GEO_06=readfloat f -- Scale
GEO_07=readlong f #unsigned -- material id
	


if GEO_05==0x00 OR GEO_05==0x03 do( -- Strip
Face_flags = #()  	
if vifCMD[3]!=1 then (

for x = 1 to GEO_01 do(
vx = (readfloat f)*mscale
vy = (readfloat f)*mscale
vz = (readfloat f)*mscale
tu = (readfloat f)
-- if GEO_07==1 DO append colorArray (color 11 00 00)
-- if GEO_07==2 DO append colorArray (color 00 22 00)
-- if GEO_07==3 DO append colorArray (color 00 00 33)
-- if GEO_07==4 DO append colorArray (color 44 00 00)
-- if GEO_07==5 DO append colorArray (color 00 55 00)
-- if GEO_07==6 DO append colorArray (color 00 00 66)
-- if GEO_07==7 DO append colorArray (color 77 00 00)
-- if GEO_07==8 DO append colorArray (color 00 88 00)
-- if GEO_07==9 DO append colorArray (color 00 00 99)
append tempWeights [1,0,0,0]
append tempBoneids [0,-1,-1,-1]
append vertArray [vx,-vz,vy] --save verts to Vert_array
append uvwArray [tu,0,0]	)
for x = 1 to GEO_01 do(
nx = (readfloat f)
ny = (readfloat f)
nz = (readfloat f)
append Face_flags (bit.get (readbyte f #unsigned) 1)
fseek f -1 #seek_cur;append normArray [nx,-nz,ny]
if uvwArray.count!=0 then (uvwArray[((uvwArray.count-GEO_01)+x)][2]=readfloat f*-1)
else(uvwArray[x][2]=readfloat f*-1))
fcnt=cnt
skip=0
bf=1
for i = 3 to GEO_01 do (
if Face_flags[i]==true do (skip=2;bf=(bf=1))
fcnt+=1;fa=fcnt;fb=fcnt+1;fc=fcnt+2
if skip<=0 do(
if bf==1 do append faceArray[fa,fb,fc]
if bf==-1 do append faceArray[fc,fb,fa]
bf=(bf*-1)	
)
skip-=1
)
cnt+=GEO_01

-- if (ftell f)!=vifCMD[5] do Print ("CRC FAIL @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set


)else(
vifCMD=readVIFcmd f

for x = 1 to GEO_01 do(
vx = (((readshort f as float)/65535)*mscale)*GEO_06*16
vy = (((readshort f as float)/65535)*mscale)*GEO_06*16
vz = (((readshort f as float)/65535)*mscale)*GEO_06*16
tu = ((readshort f as float)/65535)*16
append colorArray (color 0 0 0)
append tempWeights [1,0,0,0]
append tempBoneids [1,0,0,0]
append vertArray [vx,-vz,vy] --save verts to Vert_array
append uvwArray [tu,0,0]	)
for x = 1 to GEO_01 do(
nx = ((readshort f as float)/65535)
ny = ((readshort f as float)/65535)
nz = ((readshort f as float)/65535)
append Face_flags (bit.get (readbyte f #unsigned) 1)
fseek f -1 #seek_cur;append normArray [nx,-nz,ny]
if uvwArray.count!=0 then (uvwArray[((uvwArray.count-GEO_01)+x)][2]=((readshort f as float)/65535)*-16)
else(uvwArray[x][2]=((readshort f as float)/65535)*-16))
-- if (ftell f)!=vifCMD[5] do Print ("CRC FAIL @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set

fcnt=cnt
skip=0
bf=1
if GEO_01>=3 then(
for i = 3 to GEO_01 do (
-- if Face_flags[i]==true do (skip=2;bf=(bf=1))
fcnt+=1
fa=fcnt
fb=fcnt+1
fc=fcnt+2

if skip<=0 do(
if bf==1 do append faceArray[fa,fb,fc]
if bf==-1 do append faceArray[fc,fb,fa]
bf=(bf*-1)	
)
skip-=1
)
cnt+=GEO_01
)else(

append faceArray[(cnt+1),(cnt+2),(cnt+3)]

cnt+=GEO_01





)



)















case of(
-- 1 -- | VColours |
-- 2 -- | Colours | Bone IDs |
-- 3 -- | VColours | Bone IDs |
-- 4 -- | Colours | 2 Weights | Bone IDs |
-- 5 -- | VColours | 2 Weights | Bone IDs |
-- 6 -- | Colours | 3 Weights | Bone IDs |
-- 7 -- | VColours | 3 Weights | Bone IDs 
-- 8 -- | Colours | 4 Weights | Bone IDs |
-- 9 -- | VColours | 4 Weights | Bone IDs |

(GEO_07 == 1): ( -- | VColours |
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
colorArray[x]=(color vRed vGrn vBlu))
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 2): ( -- | Colours | Bone IDs |
vifCMD=readVIFcmd f
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
for x = 1 to GEO_01 do colorArray[x]=(color vRed vGrn vBlu)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
IF b1!=0xFF AND b2==0xFF AND b3==0xFF AND b4==0xFF DO tempWeights[x]=[1.00,0.00,0.00,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3==0xFF AND b4==0xFF DO tempWeights[x]=[0.50,0.50,0.00,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3!=0xFF AND b4==0xFF DO tempWeights[x]=[0.33,0.33,0.34,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3!=0xFF AND b4!=0xFF DO tempWeights[x]=[0.25,0.25,0.25,0.25]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)


(GEO_07 == 3): ( -- | VColours | Bone IDs |
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
colorArray[x]=(color vRed vGrn vBlu))
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
IF b1!=0xFF AND b2==0xFF AND b3==0xFF AND b4==0xFF DO tempWeights[x]=[1.00,0.00,0.00,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3==0xFF AND b4==0xFF DO tempWeights[x]=[0.50,0.50,0.00,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3!=0xFF AND b4==0xFF DO tempWeights[x]=[0.33,0.33,0.34,0.00]
IF b1!=0xFF AND b2!=0xFF AND b3!=0xFF AND b4!=0xFF DO tempWeights[x]=[0.25,0.25,0.25,0.25]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 4): ( -- | Colours | 2 Weights | Bone IDs |
vifCMD=readVIFcmd f
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
for x = 1 to GEO_01 do colorArray[x]=(color vRed vGrn vBlu)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=0
w4=0
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 5): ( -- | VColours | 2 Weights | Bone IDs |
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=0
w4=0
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 6): ( -- | Colours | 4 Weights | Bone IDs |
vifCMD=readVIFcmd f
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
for x = 1 to GEO_01 do colorArray[x]=(color vRed vGrn vBlu)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=readfloat f
w4=0
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 7): ( -- | VColours | 4 Weights | Bone IDs |
vifCMD=readVIFcmd f

vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1

if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=readfloat f
w4=0
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 8): ( -- | Colours | 4 Weights | Bone IDs |
vifCMD=readVIFcmd f
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
for x = 1 to GEO_01 do colorArray[x]=(color vRed vGrn vBlu)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=readfloat f
w4=readfloat f
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)

(GEO_07 == 9): ( -- | VColours | 4 Weights | Bone IDs |
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
vRed=readbyte f #unsigned
vGrn=readbyte f #unsigned
vBlu=readbyte f #unsigned
vAlp=(readbyte f #unsigned * 2)-1
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
	vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
w1=readfloat f
w2=readfloat f
w3=readfloat f
w4=readfloat f
tempWeights[x]=[w1,w2,w3,w4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
vifCMD=readVIFcmd f
for x = 1 to GEO_01 do (
b1=readbyte f #unsigned
b2=readbyte f #unsigned
b3=readbyte f #unsigned
b4=readbyte f #unsigned
tempBoneids[x]=[b1,b2,b3,b4]
)
if (ftell f)!=vifCMD[5] do Print ("CRC FAIL "+(GEO_07 as string)+" @ 0x"+((bit.intAsHex(ftell f))as string));fseek f vifCMD[5] #seek_set
)




)



-- for x = 1 to tempBoneids.count do(
-- if tempBoneids[x][1]!=0xFF do PRINT ("0x"+((bit.intAsHex(tempBoneids[x][1]))as string))
-- if tempBoneids[x][2]!=0xFF do PRINT ("0x"+((bit.intAsHex(tempBoneids[x][2]))as string))
-- if tempBoneids[x][3]!=0xFF do PRINT ("0x"+((bit.intAsHex(tempBoneids[x][3]))as string))
-- if tempBoneids[x][4]!=0xFF do PRINT ("0x"+((bit.intAsHex(tempBoneids[x][4]))as string))
-- )


-- print tempBoneids












































)





if GEO_05==0x01 do( -- material info
-- not deciphered yet
-- contains x,y positions for the texture, and material shading values....
-- since we don't have access to the textures, collecting this info out would be pointless

-- new material, flush geometry
if faceArray.count!=0 do(
-- Print ("NEW MATERIAL FOUND @ 0x"+((bit.intAsHex(ftell f))as string))
counter+=1
mshName=mshNames[(wtfisyous[i])];mshName+="_"
if counter<=99 do mshName+="0"
if counter<=9 do mshName+="0"
mshName+=(counter as string)
msh = mesh vertices:vertArray faces:faceArray normals:normArray name:mshName
Print (mshName+" @ 0x"+((bit.intAsHex(hereiam))as string))
msh.numTVerts = uvwArray.count
buildTVFaces msh
	setCVertMode msh true
	setNumCPVVerts msh colorArray.count
	defaultVCFaces msh
for j = 1 to uvwArray.count do setTVert msh j uvwArray[j]
for j = 1 to faceArray.count do setTVFace msh j faceArray[j]
for j = 1 to normArray.count do setNormal msh j normArray[j]
for j = 1 to colorArray.count do setVertColor msh j colorArray[j]


if skinON==true do(imSkin msh GEO_06 nodeArray boneidArray weightArray bonePallet[(wtfisyous[i])])

if normON==true do(
max modify mode
clearSelection()
select msh
normMod = Edit_Normals ()
addModifier msh normMod
ncnt=0;normMod.displayLength = 0
for j = 1 to faceArray.count do(
for h = 1 to 3 do(ncnt+=1
normMod.EditNormalsMod.SetNormalExplicit ncnt node:msh
normMod.EditNormalsMod.SetNormal (normMod.EditNormalsMod.GetNormalID j h) normArray[(faceArray[j][h])] node:msh
));subobjectLevel = 0;clearSelection())


vertArray=#()
colorArray=#()
uvwArray=#()
normArray=#()
faceArray=#()
boneidArray=#()
weightArray=#()
cnt=0)
fseek f vifCMD[5] #seek_set;if (ftell f)!=vifCMD[5] do Print ("CRC FAIL @ 0x"+((bit.intAsHex(ftell f))as string))

)















-- if CMD_04==0x01 do fseek f -4 #seek_cur


if keyboard.escPressed then exit
-- fseek f endPos #seek_set
))while vifCMD[4]!=0x17 AND ftell f!=(offsetArray[i][1]+offsetArray[i][2])





















































)
for x = 1 to tempWeights.count do( --strip ends, dump shit into master array
append boneidArray tempBoneids[x]
append weightArray tempWeights[x]	
)

)
if faceArray.count!=0 do(
-- Print ("NEW MATERIAL FOUND @ 0x"+((bit.intAsHex(ftell f))as string))
counter+=1
mshName=mshNames[(wtfisyous[i])];mshName+="_"
if counter<=99 do mshName+="0"
if counter<=9 do mshName+="0"
mshName+=(counter as string)
msh = mesh vertices:vertArray faces:faceArray normals:normArray name:mshName
Print (mshName+" @ 0x"+((bit.intAsHex(hereiam))as string))
msh.numTVerts = uvwArray.count
buildTVFaces msh
	setCVertMode msh true
	setNumCPVVerts msh colorArray.count
	defaultVCFaces msh
for j = 1 to uvwArray.count do setTVert msh j uvwArray[j]
for j = 1 to faceArray.count do setTVFace msh j faceArray[j]
for j = 1 to normArray.count do setNormal msh j normArray[j]
for j = 1 to colorArray.count do setVertColor msh j colorArray[j]

if skinON==true do(imSkin msh GEO_06 nodeArray boneidArray weightArray bonePallet[(wtfisyous[i])])
if normON==true do(
max modify mode
clearSelection()
select msh
normMod = Edit_Normals ()
addModifier msh normMod
ncnt=0;normMod.displayLength = 0
for j = 1 to faceArray.count do(
for h = 1 to 3 do(ncnt+=1
normMod.EditNormalsMod.SetNormalExplicit ncnt node:msh
normMod.EditNormalsMod.SetNormal (normMod.EditNormalsMod.GetNormalID j h) normArray[(faceArray[j][h])] node:msh
));subobjectLevel = 0;clearSelection())

-- selectNorms=#()
-- selectNorms[(msh.faces*3)]=0
-- for i = 1 to selectNorms.count do selectNorms[i]=i

-- msh.modifiers[#Edit_Normals].EditNormalsMod.SetSelection 




)

)








) -- End of PXY block Read




PRINT "DONE!!!!"

Print ("Last Read @ 0x"+((bit.intAsHex(ftell f))as string))
fclose f
) else (Print "Aborted.")